<?php
namespace SM\Factory;

use Doctrine\ORM\EntityManager;

class AssinaturaDigitalCDAFactory
{
    
    protected $connection;
    
    public function __construct(EntityManager $entityManager) {
        $this->connection = $entityManager->getConnection();
    }
    
    public function getTokenCertsign (array $params) {
        $sql = "SELECT DSTOKENCERTSIGN 
                  FROM PARAM_CENTR_ASSINATURA
                 WHERE NRORG = :NRORG";
        
        $std = $this->connection->prepare($sql);
        $std->execute($params);
        return $std->fetchAll();
    }
    
    public function getServPrestDoc (array $params) {
        $sql = "SELECT NRSERVPRESTDOC
                  FROM SERVPRESTDOC
                 WHERE IDDOCUMCERTSIGN = :IDDOCUMCERTSIGN";
        
        $std = $this->connection->prepare($sql);
        $std->execute($params);
        return $std->fetchAll();
    }

    public function recebeSignatarioCDA (array $params) {
        $sql = "SELECT NRSERVPRESTDOCASSINA
                  FROM SERVPRESTDOCASSINA
                 WHERE NRSERVPRESTDOC = :NRSERVPRESTDOC
                   AND NRCPFSIGNATARIO = :NRCPFSIGNATARIO";
        
        $std = $this->connection->prepare($sql);
        $std->execute($params);
        return $std->fetchAll();
    }

    public function updateServPrestDoc(array $params, $idSituacao) {
        if ($idSituacao == 'P'){

            $sql = "UPDATE SERVPRESTDOC
                       SET IDSITASSINATURA = :IDSITASSINATURA
                     WHERE NRSERVPRESTDOC = :NRSERVPRESTDOC";   
        }
        else if ($idSituacao == 'A'){
            $sql = "UPDATE SERVPRESTDOC
                       SET IDSITASSINATURA = :IDSITASSINATURA,
                           DTASSINATURA = SYSDATE 
                     WHERE NRSERVPRESTDOC = :NRSERVPRESTDOC";
            
        } 
        else {
            $sql = "UPDATE SERVPRESTDOC
                       SET IDSITASSINATURA = :IDSITASSINATURA,
                           DTASSINATURA = SYSDATE,
                           DSJUSTIFRECUSAASSINAT = :DSJUSTIFRECUSAASSINAT  
                     WHERE NRSERVPRESTDOC = :NRSERVPRESTDOC";
        }

        $ps = $this->connection->prepare($sql);
        $ps->execute($params);
    }

    public function recebeDadosSignatariosCDA (array $params) {
        $sql = "SELECT NRSERVPRESTDOCASSINA, IDSITASSINATURA, DSJUSTIFRECUSAASSINAT
                  FROM SERVPRESTDOCASSINA
                 WHERE NRSERVPRESTDOC = :NRSERVPRESTDOC";
        
        $std = $this->connection->prepare($sql);
        $std->execute($params);
        return $std->fetchAll();
    }

    public function  updateAssinaDocCDA (array $params) {
        $sql = "UPDATE SERVPRESTDOCASSINA
                   SET IDSITASSINATURA = :IDSITASSINATURA,
                       DTASSINATURA = SYSDATE,
                       DSJUSTIFRECUSAASSINAT = :DSJUSTIFRECUSAASSINAT  
                 WHERE NRSERVPRESTDOC = :NRSERVPRESTDOC
                   AND NRSERVPRESTDOCASSINA = :NRSERVPRESTDOCASSINA";
        
        $std = $this->connection->prepare($sql);
        $std->execute($params);
    }

    public function inserirLogAssinaturaDigitalCDA(array $params) {
        $sql = "INSERT INTO SERVPRESTDOCLOGASSDIG (
                    NRSERVPRESTDOCLOGASSDIG,    NRSERVPRESTDOC,     IDDOCUMCERTSIGN,
                    NRCPFSIGNATARIO,       DSERRO,             NRORG,
                    DTINCLUSAO
                )
                VALUES (
                    :NRSERVPRESTDOCLOGASSDIG,   :NRSERVPRESTDOC,    :IDDOCUMCERTSIGN,
                    :NRCPFSIGNATARIO,   :DSERRO,            :NRORG,
                    SYSDATE
                )";
        
        $ps = $this->connection->prepare($sql);
        $ps->execute($params);
    }
}
?>