/* Sistemas Integrados TECNISA
   Gesto de Projetos

Nome: 8802_GEPSTPO.sql

Descrio:
Altera o caminho do requisito quando sua pasta teve seu nome alterado.

Criao:
27/10/2003 Tlio Adriano Roversi Rosa
*/

CREATE OR REPLACE PROCEDURE ALTERA_CAMINHO
   (P_NRPASTARPROD IN ARVOREQPROD.NRPASTARPROD%TYPE,
    P_OLDNMPASTA   IN ARVOREQPROD.NMPASTARPROD%TYPE,
    P_NEWNMPASTA   IN ARVOREQPROD.NMPASTARPROD%TYPE) AS

   V_NRPASTARPROD REQUISITPROD.NRPASTARPROD%TYPE;
   V_NMPASTARPROD ARVOREQPROD .NMPASTARPROD%TYPE;
   V_OLDDSPASTA   REQUISITPROD.DSPASTARPROD%TYPE;
   V_NEWDSPASTA   REQUISITPROD.DSPASTARPROD%TYPE;

BEGIN

   V_NRPASTARPROD := P_NRPASTARPROD;
   V_OLDDSPASTA   := P_OLDNMPASTA;
   V_NEWDSPASTA   := P_NEWNMPASTA;

   LOOP
      SELECT 
         MAX(A1.NRPASTARPROD),
         MAX(A1.NMPASTARPROD)
      INTO 
         V_NRPASTARPROD,
         V_NMPASTARPROD
      FROM 
         ARVOREQPROD A1, 
         ARVOREQPROD A2
      WHERE 
         (A1.NRPASTARPROD = A2.NRPASRPROANT) AND
         (A2.NRPASTARPROD = V_NRPASTARPROD);

      EXIT WHEN V_NRPASTARPROD IS NULL;

      V_OLDDSPASTA := V_NMPASTARPROD||'\'||V_OLDDSPASTA;
      V_NEWDSPASTA := V_NMPASTARPROD||'\'||V_NEWDSPASTA;
   END LOOP;

   UPDATE REQUISITPROD RP
   SET DSPASTARPROD = (SELECT 
                          V_NEWDSPASTA||SUBSTR(DSPASTARPROD, LENGTH(V_OLDDSPASTA) + 1, LENGTH(DSPASTARPROD) - LENGTH(V_OLDDSPASTA))
                       FROM 
                          REQUISITPROD
                       WHERE 
                          (CDPRODGRUP = RP.CDPRODGRUP) AND
                          (CDREQPROD  = RP.CDREQPROD ))
   WHERE 
      (DSPASTARPROD LIKE V_OLDDSPASTA||'%');
END;
/
